#include <stdio.h>

/* Filtre transformant des donnees binaires en un format hybride        */
/* hexa-ascii destine a etre edite. Argument: nombre d'octets par ligne */
/* Option: -h pour hexa seul 						*/
/* Julien Cassaigne 1990                                                */

digit(c)
char c;
    {
	if (c<10) putchar (c+48);
	else putchar (c+55);
    }

puthexa(c)
char c;
    {
	digit((c>>4)&15);
	digit(c&15);
    }
main(argc,argv)
int argc;
char **argv;
    {
	int c,i,m=40,touthexa=0;

	if (argc>1 && !strcmp(argv[1],"-h"))
	    {
		argc--;
		argv++;
		touthexa=1;
	    }
	if (argc>1)
	    m=atoi(argv[1]);
	c=getchar();
	i=0;

	while (c != EOF)
	    {
		if (touthexa || c<32 || c==127)
			puthexa (c);
		else if (c<128)
		    {
			putchar ('-');
			putchar (c);
		    }
		else if (c<160 || c==255)
			puthexa (c);
		else
		    {
			putchar ('+');
			putchar (c-128);
		    }
		i++;
		if (i==m)
		    {
			putchar (10);
			i=0;
		    }
		c = getchar();
	    }
	putchar (10);
	exit (0);
    }
